/*
 * Copyright (c) 1995-2012, Index Datassss
 * All rights reserved.
 * See the file LICENSE for details.
 */
package com.indexdata.torus2.query.match.term;

import com.indexdata.torus2.query.Tokenizer;
import com.indexdata.torus2.query.match.TermMatcher;
import static com.indexdata.torus2.query.MatchingUtil.*;
import java.util.ArrayList;
import java.util.List;
import org.apache.log4j.Logger;

/**
 *
 * @author jakub
 */
public class AllTermMatcher implements TermMatcher {
  private List<String> terms;
  private static Logger logger = Logger.getLogger("com.indexdata.torus2");

  public AllTermMatcher(String term) {
    Tokenizer tokenizer = new Tokenizer(term, Tokenizer.TokenizerType.QUERY);
    terms = new ArrayList<String>();
    while (tokenizer.hasMoreElements()) {
      terms.add(deAnchorTerm(tokenizer.nextElement()));
    }
  }

  @Override
  public boolean match(String value) {
    String nValue = normalizeTokens(value, " ", 
      Tokenizer.TokenizerType.FIELD);
    nValue = surround(nValue, " ");
    for (String nTerm : terms) {
      if (logger.isDebugEnabled()) {
        logger.debug("normalized: term '" + nTerm + "' ?= value '" + nValue + "'");
      }
      if (!equalsWildcard(nTerm, 0, nValue, 0))
        return false;
    }
    return true;

  }
}
